﻿using System.Threading.Tasks;

using Newtonsoft.Json;

namespace TestProject;

/// <summary>
/// JSON 헬퍼
/// </summary>
public static class JSONHelper
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Public

    #region 직렬화하기 (비동기) - SerializeAsync(item)

    /// <summary>
    /// 직렬화하기 (비동기)
    /// </summary>
    /// <param name="item">항목</param>
    /// <returns>JSON 문자열 태스크</returns>
    public static async Task<string> SerializeAsync(object item)
    {
        return await Task.Run<string>
        (
            () =>
            {
                return JsonConvert.SerializeObject(item);
            }
        );
    }

    #endregion
    #region 역직렬화하기 (비동기) - DeserializeAsync<TItem>(json)

    /// <summary>
    /// 역직렬화하기 (비동기)
    /// </summary>
    /// <typeparam name="TItem">항목 타입</typeparam>
    /// <param name="json">JSON 문자열</param>
    /// <returns>항목 태스크</returns>
    public static async Task<TItem> DeserializeAsync<TItem>(string json)
    {
        return await Task.Run<TItem>
        (
            () =>
            {
                return JsonConvert.DeserializeObject<TItem>(json);
            }
        );
    }

    #endregion
}